
let current = GetCurrentScriptDirectory;
let SpellActive = false;
let bg1 = GetMainStgScriptDirectory~"source/Stage/stage01a.png";
let bg2 = GetMainStgScriptDirectory~"source/Stage/stage01b.png";

@Initialize{
	StageExBg;
	SetAutoDeleteObject(true);
}
@MainLoop{yield;}

task StageExBg{
	let StageBG1;	
	let StageBG2;	
	let StageBG3;	
	
	let osize = 0;
	let obj_sizeset = 0;
	let sizeinc = 0;
	
	
	SetCameraFocusX(0);
	SetCameraFocusY(0);
	SetCameraFocusZ(0);
	SetCameraRadius(300);
	SetCameraElevationAngle(76);
	SetCameraAzimuthAngle(90);	
	
	StageBG1 = Create3DProperties(255, 1024, bg1, 0.73);
	StageBG2 = Create3DProperties(55, 1024, bg2, 0.74);
	StageBG3 = Create3DProperties(85, 1024, bg2, 0.74);
	
	ObjRender_SetPosition(StageBG1, 0, -871, -580);
	ObjRender_SetAngleXYZ(StageBG1, 50, 0, 90);
	
	ObjRender_SetPosition(StageBG2, 0, -615, -350);
	ObjRender_SetAngleXYZ(StageBG2, 50, 0, 180);
	
	ObjRender_SetPosition(StageBG3, 0, -620, -465);
	ObjRender_SetAngleXYZ(StageBG3, 50, 0, 180);
	Begin;
	let ypos = 0;
	let ypos2 = 0;
	let ypos3 = 0;
	yield;
	
	while(GetCommonData("SelectionSet", 2)!=2){yield}
	if(GetCommonData("quality", 2)==0){CloseScript(GetOwnScriptID);}
	
	loop{
		
		SetCameraFocusX(osize-75);
		SetCameraAzimuthAngle(osize/18+85);	
		CameraShiftX;
		
		ObjSprite3D_SetSourceRect(StageBG1, 0, ypos, 2048, ypos+2048);
		ObjSprite3D_SetSourceRect(StageBG2, ypos2*2, ypos2, ypos2*2+2048, ypos2+2048);
		ObjSprite3D_SetSourceRect(StageBG3, ypos2*2, ypos3, ypos2*2+2048, ypos3+2048);
		ypos-=4;
		ypos2+=1;
		ypos3-=1;
		if(ypos > 2048*2-1){ypos = 0}
		if(ypos2 > 2048*2-1){ypos2 = 0}
		if(ypos3 > 2048*2-1){ypos3 = 0}
		
		yield;
	}
	
	task Begin{
		// 144-64-64
		SetFogEnable(true);
		SetFogParam(-200, -100, 144, 164, 180);
		while(GetCommonData("SelectionSet", 0) != 2){yield}
		Obj_SetRenderPriority(StageBG1, 0.20);
		Obj_SetRenderPriority(StageBG2, 0.21);
		Obj_SetRenderPriority(StageBG3, 0.21);
		loop(12){yield;}
		ascent(i in 0..400){
			SetFogParam(i*2, i*3.5, 144, 164, 180);
			yield;
		}
	}
	
	task CameraShiftX{
		let ax2 = 0.01;
		let bx2 = 1.25;
		
		if(obj_sizeset==0){sizeinc+=ax2}
		if(obj_sizeset==1){sizeinc-=ax2}		
		if(sizeinc<-bx2){obj_sizeset=0}
		if(sizeinc>bx2){obj_sizeset=1}
		
		osize+=sizeinc;		
	}
	
	function Create3DProperties(alpha, srcrect, image, priority){
		let StageProp = ObjPrim_Create(OBJ_SPRITE_3D);
		ObjRender_SetBlendType(StageProp, BLEND_ALPHA);
		ObjRender_SetAlpha(StageProp, alpha);
		ObjPrim_SetTexture(StageProp, image);
		Obj_SetRenderPriority(StageProp, priority);
		ObjSprite3D_SetSourceRect(StageProp, 0, 0, srcrect, srcrect);
		ObjSprite3D_SetDestRect(StageProp, -srcrect, -srcrect, srcrect, srcrect);
		ObjRender_SetZWrite(StageProp, true);
		ObjRender_SetZTest(StageProp, true);
		return StageProp;
	}
}
