

task AnimateBossM1(objID, x, y){
	let anim_count = 0;
	let anim_type = 0;
	AuraOnBossSingle(objID, 255, 64, 64);
	NameOnBossSingle(objID, "Mamizou Futatsuiwa");
	let xoffset = 0;
	let yoffset = 0;
	
	let idle = 10;
	let move = 4;
	let attack = 6;
	
	let r = idle; // Frames yielded before moving to next frame
	let ad = 35; // Frames yielded while "charging" attack animation
	let m = 0; 
	let xo = 0;
	let yo = 0;
	
	while(!Obj_IsDeleted(objID)){
		if(Anim_Attack==0){
			if(ObjMove_GetSpeed(objID) <= 1){
				if(anim_type == 1){
					anim_count = 0;
					anim_type = 2;
				}
				if(anim_type == 3){
					anim_type=4;
					anim_count = 0;
				}
			}
			if(ObjMove_GetSpeed(objID) > 1){
				if(anim_type == 0){
					anim_count = 0;
					anim_type = 1;
				}
			}
		}else{
			r = attack;
			IsAttackAnimPlaying = true;
			if(anim_type != 3){
				if(Anim_Attack==1){anim_count = 0;}
				else{anim_count = r*4+ad;}
				anim_type=3;
					
			}
		}		
		if(CheckDirection(objID, "right") == true){ObjRender_SetScaleXYZ(objID, 1, 1, 1)}
		if(CheckDirection(objID, "left") == true){ObjRender_SetScaleXYZ(objID, -1, 1, 1)}
		
		if(anim_type==0){ //Idle
			r = idle;
			yoffset = 0;
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, 0, yoffset, x, yoffset+y);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x, yoffset, x*2, yoffset+y);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, x*2, yoffset, x*3, yoffset+y);}
			if(anim_count >= r*3){ObjSprite2D_SetSourceRect(objID, x, yoffset, x*2, yoffset+y);}
			if(anim_count >= r*4){ObjSprite2D_SetSourceRect(objID, 0, yoffset, x, yoffset+y);}
			if(anim_count >= r*5){ObjSprite2D_SetSourceRect(objID, x, yoffset, x*2, yoffset+y);}
			if(anim_count >= r*6){ObjSprite2D_SetSourceRect(objID, x*3, yoffset, x*4, yoffset+y);}
			if(anim_count >= r*7){ObjSprite2D_SetSourceRect(objID, x*2, yoffset, x*3, yoffset+y);}
			if(anim_count >= r*8){ObjSprite2D_SetSourceRect(objID, x, yoffset, x*2, yoffset+y);}
			if(anim_count >= r*9-1){anim_count = -1;}
		}
		if(anim_type==1){ //Moving
			r = move;
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, 0, yoffset+y, x, yoffset+y*2);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x, yoffset+y, x*2, yoffset+y*2);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, x*2, yoffset+y, x*3, yoffset+y*2);}
			if(anim_count >= r*3){ObjSprite2D_SetSourceRect(objID, x*3, yoffset+y, x*4, yoffset+y*2);}
		}
		if(anim_type==2){ //Moving to idle
			r = move;
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, x*3, yoffset+y, x*4, yoffset+y*2);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x*2, yoffset+y, x*3, yoffset+y*2);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, x, yoffset+y, x*2, yoffset+y*2);}
			if(anim_count >= r*3){ObjSprite2D_SetSourceRect(objID, 0, yoffset+y, x, yoffset+y*2);}
			if(anim_count >= r*4-r/2){anim_type=0; anim_count=0;yoffset = 0;}
		}
		if(anim_type==3){ //Attack
			if(anim_count >= 0){ObjSprite2D_SetSourceRect(objID, 0, yoffset+y*2, x, yoffset+y*3);}
			if(anim_count >= r){ObjSprite2D_SetSourceRect(objID, x, yoffset+y*2, x*2, yoffset+y*3);}
			if(anim_count >= r*2){ObjSprite2D_SetSourceRect(objID, x*2, yoffset+y*2, x*3, yoffset+y*3);}
			if(anim_count >= r*3){ObjSprite2D_SetSourceRect(objID, x*3, yoffset+y*2, x*4, yoffset+y*3);}
			if(anim_count >= r*4){ObjSprite2D_SetSourceRect(objID, x*2, yoffset+y*2, x*3, yoffset+y*3);}
			if(anim_count >= r*5){ObjSprite2D_SetSourceRect(objID, x, yoffset+y*2, x*2, yoffset+y*3);}
			if(anim_count >= r*6-1){anim_count = -1;}
		}
		if(anim_type==4){ //Attack to idle
			if(anim_count >= 0){anim_count=0;anim_type=0;IsAttackAnimPlaying=false;}
		}
		m+=1;
		ObjSprite2D_SetDestRect(objID, -x/2, -y/2+(4*sin(m)), x/2, y/2+(4*sin(m)));
		if(!IsTimeStopped){anim_count++;}
		yield;
	}
}

task AnimateBossD1(objID, x, y){
	//Alice 48;64
	let anim_count = 0;
	let anim_type = 0;
	
	let xoffset = 0;
	let yoffset = 0;
	
	let idle = 0;
	let move = 4;
	let attack = 6;
	
	let r = idle; // Frames yielded before moving to next frame
	
	let m = 0;
	
	while(!Obj_IsDeleted(objID)){
		if(ObjMove_GetSpeed(objID) == 0){
			if(anim_type == 1){
				anim_count = 0;
				anim_type = 2;
			}
		}
		if(ObjMove_GetSpeed(objID) > 0){
			if(anim_type == 0){
				anim_count = 0;
				anim_type = 1;
			}
		}
		if(Anim_Attack == 1){
			r = attack;
			IsAttackAnimPlaying = true;
			if(anim_type != 3){
				anim_type=3;
				anim_count = 0;
			}
		}
		
		if(CheckDirection(objID, "right") == true){ObjRender_SetScaleXYZ(objID, 1, 1, 1)}
		if(CheckDirection(objID, "left") == true){ObjRender_SetScaleXYZ(objID, -1, 1, 1)}
		
		
		if(anim_type==0){ //Idle
			ObjSprite2D_SetSourceRect(objID, 0, yoffset, x, yoffset+y);
		}
		if(anim_type==1){ //Moving
			r = move;
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, 0, yoffset+y, x, yoffset+y*2);}
			if(anim_count == r){ObjSprite2D_SetSourceRect(objID, x, yoffset+y, x*2, yoffset+y*2);}
			if(anim_count == r*2){ObjSprite2D_SetSourceRect(objID, x*2, yoffset+y, x*3, yoffset+y*2);}
			if(anim_count == r*3){ObjSprite2D_SetSourceRect(objID, x*3, yoffset+y, x*4, yoffset+y*2);}
			if(anim_count == r*4){ObjSprite2D_SetSourceRect(objID, x*4, yoffset+y, x*5, yoffset+y*2);}
		}
		if(anim_type==2){ //Moving to idle
			r = move;
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, x*4, yoffset+y, x*5, yoffset+y*2);}
			if(anim_count == r){ObjSprite2D_SetSourceRect(objID, x*3, yoffset+y, x*4, yoffset+y*2);}
			if(anim_count == r*2){ObjSprite2D_SetSourceRect(objID, x*2, yoffset+y, x*3, yoffset+y*2);}
			if(anim_count == r*3){ObjSprite2D_SetSourceRect(objID, x, yoffset+y, x*2, yoffset+y*2);}
			if(anim_count == r*4){ObjSprite2D_SetSourceRect(objID, 0, yoffset+y, x, yoffset+y*2);}
			if(anim_count == r*5){anim_type=0; anim_count=0;}
		}
		if(anim_type==3){ //Attack
			r = attack;
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, x, yoffset, x*2, yoffset+y*2);}
			if(anim_count == r){ObjSprite2D_SetSourceRect(objID, x*2, yoffset, x*3, yoffset+y*2);}
			if(anim_count == r*2){ObjSprite2D_SetSourceRect(objID, x*3, yoffset, x*4, yoffset+y*2);}
		}
		if(anim_type==4){ //Attack to idle
			r = attack;
			if(anim_count == 0){ObjSprite2D_SetSourceRect(objID, x*3, yoffset, x*4, yoffset+y*2);}
			if(anim_count == r){ObjSprite2D_SetSourceRect(objID, x*2, yoffset, x*3, yoffset+y*2);}
			if(anim_count == r*2){ObjSprite2D_SetSourceRect(objID, x, yoffset, x*2, yoffset+y*2);}
			if(anim_count >= r*3-r/2){anim_count=0;anim_type=0;IsAttackAnimPlaying=false;}
		}
		
		m+=1;
		ObjSprite2D_SetDestRect(objID, -x/2, -y/2+(4*sin(m)), x/2, y/2+(4*sin(m)));
		if(!IsTimeStopped){anim_count++;}
		yield;
	}
}

