//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss2.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(45);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 64, 80);
	SetInvincibility(Enemy, 300, 155, 95);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 10, 3);
  
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(!Obj_IsDeleted(Enemy)){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(!EnemyDead){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 140;
	let sframe2 = -1;
	let sframe22 = 1;
	let sframe3 = -6;
	let sloop = 0;
	loop(144){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0){
		if(Enemy_Move>rand(345, 600)){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}   
		if(sframe>=85){
			Enemy_Move++;
			if(sframe3>5-round(argument/24)){
				sloop = round(argument/12)+4;
				sframe2+=2;
				if(sframe2>=2){sframe2 = -1;}
					loop(sloop){
					CreateArrowObjShotA1(EnemyX, EnemyY, argument/32+2.25, sframe2, angle, DS_BILL_RED, 13,255,64,64);
					angle+=360/sloop;
				}
				PlaySound("smbullet");
				sframe3 = 0;
			}
			sframe3++;
			angle+=4.25*sframe22;
			if(sframe>=305){Enemy_Move+=185;sframe = 0;sframe22+=2;if(sframe22>=2){sframe22 = -1;}}
		}
		sframe++;
		Enemy_Move++;
		yield;
	}
	EnemyDead = true;
	Obj_Delete(Enemy);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateArrowObjShotA1(x, y, spd, mod, ang, graph, delay,r,g,b){
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);	
	ObjMove_SetAngularVelocity(objShot, (argument/145+0.5375)*mod);
	let A = 0;
	while(!Obj_IsDeleted(objShot)){
		x = ObjMove_GetX(objShot);
		y = ObjMove_GetY(objShot);
		A = ObjMove_GetAngle(objShot);
		ObjShot_SetIntersectionCircleA2(objShot, x+8*cos(A),  y+8*sin(A), 2);
		yield;
	}
	if(quality<=1){return;}
	ObjShot_BulletBreak(x, y, r, g, b)
}


