//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(39);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 175, 115, 110);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 10, 3);
  
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(!Obj_IsDeleted(Enemy)){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(!EnemyDead){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 145;
	let sframe2 = -1;
	let sframe3 = -6;
	let sframe33 = 400;
	let s = 28;
	let s2 = 0;
	let sloop = 0;
	let angle2 = 0;
	let cx = GetCenterX;
	let cy = GetCenterY*1.35;
	let bx = GetCenterX;
	let by = GetCenterY*1.35;
	loop(144){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(time>200){
			if(sframe3>5-round(argument/24)){
				s++;
				sloop = round(argument/12)+3;
				loop(sloop){
					let c = CreateObjShotA1(cx+sframe33*cos(angle2), cy+sframe33*sin(angle2), 6, angle2, DS_BALL_M_RED, 13,255,64,64);
					angle2+=360/sloop;
				}
				PlaySound("smbullet");
				sframe3 = 0;		
				if(cx > bx+3 || cy > by+3 || cx < bx-3 || cy < by-3){ 
					cx = cx+(GetDistance(bx,by,cx,cy)/26)*cos(atan2(by-cy, bx-cx));
					cy = cy+(GetDistance(bx,by,cx,cy)/26)*sin(atan2(by-cy, bx-cx));
				}
				if(s>=86){bx = rand(32, GetCenterX-32)+s2; by = rand(GetCenterY, GetStgFrameHeight-32);s = 0;s2+=GetCenterX;if(s2>GetCenterX){s2 = 0;}}
			}
			sframe33 = max(sframe33-1.5, 128);
			angle2+=1.75;
			sframe3++;
		}
		if(sframe>=50-argument/2){
			let nan = GetAngleToPlayer(Enemy);
			sloop = round(argument/5)+14;
			let sloop2 = sloop/1.35;
			loop(sloop){
				CreateObjShotA1(EnemyX+32*cos(nan ), EnemyY+32*sin(nan ), argument/24+1.85, nan , DS_BALL_S_BLUE, 13,64,64,255);
				nan +=360/sloop;
			}
			PlaySound("smbullet");
			sframe = 0;
		}
		sframe++;
		Enemy_Move++;
		yield;
	}
	EnemyDead = true;
	Obj_Delete(Enemy);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

