//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss2.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_IS_DURABLE_SPELL){SetScriptResult(false);}
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55);}
	case(EV_REQUEST_SPELL_SCORE){SetScriptResult(8750000);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 64, 80);
	SetInvincibility(Enemy, 300, 28, 18);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 10, 3);
	
	let str = "Pseudo Youkai Termination Seal";
	if(argument == 12){str = "Psuedo Youkai Binding Seal";}
	if(argument == 36){str = "Pseudo Anti Youkai Seal";}
	if(argument == 48){str = "Pseudo Youkai Extermination Seal";}
	if(argument == 72){str = "Pseudo Youkai Extermination Seal";}
	if(argument >= 73){str = "Pseudo Youkai Termination Seal";}
	CutInS1(Enemy, "NAZRIN", "Transformation \""~str~"\"", BossCutIn, 0, 0, 238, 511);
	ObjEnemyBossScene_StartSpell(objScene);
	PlaySound("spell");
    
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(Obj_IsDeleted(Enemy)==false){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(EnemyDead == false){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 0;
	let sframe2 = -1;
	let sframe3 = 0;
	let s = 0;
	let sloop = 0;
	loop(64){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe==75){
			if(s==0){ConcentrationF1(Enemy, 255, 76, 76, 35);PlaySound("charge");}
			s++;if(s>=2){s = 0;}
		}
		
		if(sframe>=100){
			Enemy_Move++;
			if(sframe==120){sframe3 = 6;Anim_Attack=1;}
			if(sframe3>=6){
				let newan = (argument/12+2)*3;
				let bcount = 0;
				let col = DS_BILL_GREEN;
				if(sframe==120){col = DS_BILL_YELLOW;}
				
				sloop = round((argument/12)+2);
				loop(sloop){
					CreateObjShotA2(EnemyX+32*cos(270-newan), EnemyY+32*sin(270-newan), (argument/36+2.65)/1.45, 0.275-bcount/75, 270-newan, col, 13,64,255,64);
					CreateObjShotA2(EnemyX+32*cos(270+newan), EnemyY+32*sin(270+newan), (argument/36+2.65)/1.45, 0.275-bcount/75, 270+newan, col, 13,64,255,64);
					bcount++;
					newan += 150/((argument/12+2)*3);
				}
				sframe3 = 0;
				PlaySound("smbullet");
			}
			sframe3++;
		}
		if(sframe>=155){sframe = -45;Anim_Attack=0;Enemy_Move+=100;}
		
		if(sframe2>120-argument/2){
			let newan = GetAngleToPlayer(Enemy);			
			sloop = round((argument/2.25)+3);
			loop(sloop){
				CreateObjShotA1(EnemyX, EnemyY, (argument/32+2.45)/1.65, newan, DS_BALL_L_RED, 13,255,64,64);
				newan += 360/sloop;
			}
			PlaySound("labullet");
			sframe2 = 0;
		}
		if(time>300){sframe2++;}
		sframe++;
		Enemy_Move++;
		yield;
	}
	CreateCircleA1(Enemy, 0, 7, 128, 255, 128, 64);
	PlaySound("barrage");
	loop(quality*20){ExplosionA2(EnemyX, EnemyY, rand(-360, 360), rand(-360, 360), rand(-360, 360), rand(1, 3));}	
	yield;
	FinalizeSpell;
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateObjShotA2(x, y, spd, dec, ang, graph, delay,r,g,b){
	if(graph == DS_BILL_YELLOW){r=255;g=255;b=64;}
	let ospd = spd;
	spd = spd*2;
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);	
	let mod = 3;
	let btime = 0;
	ObjShot_SetAutoDelete(objShot, false);
	while(!Obj_IsDeleted(objShot)&&btime<20){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		btime++;
		yield;
	}
	let A = 0;
	while(!Obj_IsDeleted(objShot)&&btime<160){
		btime++;
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		A = ObjMove_GetAngle(objShot);
	
		let dir = GetAngleToPlayer(objShot);
		let diff = dir - A;
		while(diff >= 180) { diff -= 360; }
		while(diff < -180) { diff += 360; }
		let diffAbs = (|diff|);
		if(diffAbs <= mod) {
			A = dir;
		}else{
			A += mod * diff / diffAbs;
		}
		ObjMove_SetSpeed(objShot, spd);	
		ObjMove_SetAngle(objShot, A);	
		spd = max(spd-dec, ospd);
		mod = max(mod-0.015, 1);
		
		yield;
	}
	
	ObjShot_SetAutoDelete(objShot, true);
	while(!Obj_IsDeleted(objShot)&&graph != DS_BILL_YELLOW){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);	
		yield;
	}
	
	if(!Obj_IsDeleted(objShot)&&graph == DS_BILL_YELLOW){
		CreateObjShotM1(x, y, ospd/2, 90, 296, delay,255,64,64, "red");
		if(argument!=12){
			CreateObjShotM1(x, y, ospd, 90-65, 299, delay, 255,64,64,"red");
			CreateObjShotM1(x, y, ospd, 90+65, 299, delay, 255,64,64,"red");
		}
		PlaySound("barrage2");
		Obj_Delete(objShot);
		return;
	}
	if(quality<=1){return;}
	ObjShot_BulletBreak(x, y, r, g, b)
}



