//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_IS_DURABLE_SPELL){SetScriptResult(false);}
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55);}
	case(EV_REQUEST_SPELL_SCORE){SetScriptResult(8750000);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 300, 25, 10);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 10, 3);
	
	let str = "Apian Danmaku Transformation";
	if(argument == 12){str = "Apian Danmaku Transformation";}
	if(argument == 36){str = "Apian Danmaku Transformation";}
	if(argument == 48){str = "Apian Danmaku Transformation";}
	if(argument == 72){str = "Apian Danmaku Transformation";}
	if(argument >= 73){str = "Apian Danmaku Transformation";}
	CutInS1(Enemy, "NAZRIN", "New Duel \""~str~"\"", BossCutIn, 0, 0, 238, 511);
	ObjEnemyBossScene_StartSpell(objScene);
	PlaySound("spell");	
    
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(Obj_IsDeleted(Enemy)==false){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(EnemyDead == false){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 0;
	let sframe2 = -1;
	let sframe3 = 0;
	let s = 0;
	let sloop = 0;
	loop(64){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe==85){
			if(s==0){ConcentrationF3(Enemy, 255, 76, 76, 35);PlaySound("charge");Anim_Attack = 1;}
			s++;if(s>=2){s = 0;}
		}
		
		if(sframe==115){
			Enemy_Move+=55;
			let nan = GetAngleToPlayer(Enemy)+90;
			if(round(rand(0,1))==1){nan += 180;}
			sloop = round(argument/36+0.4)+1;
			loop(sloop){
				CreateObjShotA3(EnemyX, EnemyY, 6, nan, DS_BALL_L_YELLOW, 15,255,255,64);
				nan += 360/sloop;
			}
			PlaySound("labullet");
			sframe = -35;Anim_Attack=0;
		}
		sframe++;
		angle++;
		Enemy_Move++;
		yield;
	}
	FinalizeSpell;
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateObjShotA3(x, y, spd, ang, graph, delay,r,g,b){
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetSpellResist(objShot, true);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	
	ObjMove_SetSpeed(objShot, spd);
	ObjMove_SetMaxSpeed(objShot, 0);
	ObjMove_SetAcceleration(objShot, -0.215);
	
	while(!Obj_IsDeleted(objShot)&&ObjMove_GetSpeed(objShot)>0.05){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		yield;
	}
	ang = GetAngleToPlayer(objShot);
	
	let btime = 0;
	let bfr = 0;
	
	while(!Obj_IsDeleted(objShot)&&btime<180){
		btime++;
		if(bfr>=30-(argument/12)*3){
			let nan = btime*3.45;
			let sloop = round(argument/16)+3;
			loop(sloop){
				CreateObjShotA2(x, y, (argument/48+2.65)/1.65, nan+rand(-15, 15), DS_BALL_S_YELLOW, 13,255,255,64);
				nan += 360/sloop;
			}
			bfr = 0;
			PlaySound("smbullet");
		}
		bfr++;
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		yield;
	}
	Obj_Delete(objShot);
	if(quality<=1){return;}
	FinalizeFairy(x, y, "yellow");
}



task CreateObjShotA2(x, y, spd, ang, graph, delay,r,g,b){
	let ospd = spd;
	spd = 6;
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	
	ObjMove_SetSpeed(objShot, spd);
	ObjMove_SetMaxSpeed(objShot, 0);
	ObjMove_SetAcceleration(objShot, -0.25);
	
	while(!Obj_IsDeleted(objShot)&&ObjMove_GetSpeed(objShot)>0.35){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		if(GetPlayerState==STATE_DOWN){Obj_Delete(objShot);}
		yield;
	}
	
	if(!Obj_IsDeleted(objShot)){
		CreateObjShotM1(x, y, ospd, ang, 301, delay, r,g,b,"yellow");
		PlaySound("smbullet");
		Obj_Delete(objShot);
		return;
	}
	if(quality<=1){return;}
	ObjShot_BulletBreak(x, y, r, g, b);
}



