//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_IS_DURABLE_SPELL){SetScriptResult(false);}
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55);}
	case(EV_REQUEST_SPELL_SCORE){SetScriptResult(8750000);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 145, 20, 18);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 10, 3);
	
	let str = "Rampant Bird Flock";
	if(argument == 12){str = "Flock of Birds";}
	if(argument == 36){str = "Wild Bird Pack";}
	if(argument == 48){str = "Wild Bird Flock";}
	if(argument == 72){str = "Rampant Bird Flock";}
	if(argument >= 73){str = "Avian Danmaku Rampancy";}
	CutInS1(Enemy, "NAZRIN", "New Duel \""~str~"\"", BossCutIn, 0, 0, 238, 511);
	ObjEnemyBossScene_StartSpell(objScene);
	PlaySound("spell");
    
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(Obj_IsDeleted(Enemy)==false){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(EnemyDead == false){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 0;
	let sframe2 = 0;
	let sf2an = 0;
	let sframe3 = 0;
	let s = 0;
	let sloop = 0;
	loop(64){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe==75){
			if(s==0){ConcentrationF1(Enemy, 255, 76, 76, 35);PlaySound("charge");Anim_Attack=1;}
			s++;if(s>=2){s = 0;}
		}
		
		if(sframe>=100){
			Enemy_Move++;
			let offset = 0;
			if(sframe3>=6){			
				sloop = ceil((argument/24));
				loop(sloop){
					CreateObjShotA2(EnemyX-128*cos(angle), EnemyY-128*sin(angle), (argument/36+2.65)/1.45, angle, DS_BALL_S_RED, 15,255,64,64);
					CreateObjShotA2(EnemyX+128*cos(angle), EnemyY+128*sin(angle), (argument/36+2.65)/1.45, angle+180, DS_BALL_S_RED, 15,255,64,64);
					angle += 360/sloop/2;
				}
				sframe3 = 0;
				PlaySound("smbullet");
			}
			if(sframe2>=2&&GetPlayerState!=STATE_DOWN){
				let bs = CreateObjShotM1(-14+offset, sf2an, rand(0, 1.15), rand(-15, 15), 297, 0,64,255,64,"green");
				ObjMove_SetMaxSpeed(bs, (argument/36+2.65)/1.45);
				ObjMove_SetAcceleration(bs, rand(0.015, 0.035));
				sframe2 = 0;
			}
			sframe3+=argument/28;
			sframe2+=argument/32;
			angle+=argument/38+0.75;
			sf2an+=GetStgFrameHeight/85;
		}
		if(sframe>=185){sframe = -45;Anim_Attack=0;Enemy_Move+=100;sf2an=0;}
		
		sframe++;
		Enemy_Move++;
		yield;
	}
	
	FinalizeSpell;
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateObjShotA2(x, y, spd, ang, graph, delay,r,g,b){
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);	
	
	let btime = 0;
	
	while(!Obj_IsDeleted(objShot)&&spd*btime<256){
		btime++;
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);		
		yield;
	}
	
	if(!Obj_IsDeleted(objShot)){
		CreateObjShotM1(x, y, spd, ang+180, 299, delay-3,255,64,64, "red");
		PlaySound("barrage2");
		Obj_Delete(objShot);
		return;
	}
	if(quality<=1){return;}
	ObjShot_BulletBreak(x, y, r, g, b)
}



