//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_IS_DURABLE_SPELL){SetScriptResult(false);}
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55);}
	case(EV_REQUEST_SPELL_SCORE){SetScriptResult(8750000);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 48, 80);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 300, 18, 18);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 10, 3);
	
	let str = "Pollinate the ";
	let str2 = "Flowers";
	
	if(GetPlayerID == "gt_CirnoA01"){str2 = "Idiot Ice Fairy";}
	if(GetPlayerID == "ds_AyaP"){str2 = "Incompetent Tengu Photorgrapher";}
	if(GetPlayerID == "gt_MarisaA01"){str2 = "Old Time Magician";}
	if(GetPlayerID == "gt_MarisaB"){str2 = "Unordinary Magician";}
	if(GetPlayerID == "gt_SakuyaA01"){str2 = "Old Time Maid";}
	if(GetPlayerID == "gt_SakuyaB"){str2 = "Imperfect Maid";}
	if(GetPlayerID == "gt_EienteiA01"){str2 = "Lunar Rabbits";}
	if(GetPlayerID == "gt_HiganA01"){str2 = "Lazy Servant And Overbearing Boss";}
	if(GetPlayerID == "gt_PrismA01"){str2 = "Noisy Poltergeists";}
	if(GetPlayerID == "gt_YoumuA01"){str2 = "Awkward Half Human";}
	if(GetPlayerID == "gt_MokouA01"){str2 = "Eternally Lost Human";}
	if(GetPlayerID == "gt_SatoriA01"){str2 = "Disliked Mind Reader";}
	if(GetPlayerID == "gt_YukaA01"){str2 = "Flower Master";}
	if(GetPlayerID == "gt_ReimuA01"){str2 = "Unreasonable Shrine Maiden";}
	if(GetPlayerID == "gt_KogasaA01"){str2 = "Unsurprising Umbrella";}
	if(GetPlayerID == "gt_MystiaA01"){str2 = "Noisy Bird";}
	if(GetPlayerID == "gt_MamizouA01"){str2 = "Elegant Tankuki";}
	if(GetPlayerID == "gt_YuyukoA01"){str2 = "Absent Minded Ghost Queen";}
	if(GetPlayerID == "gt_NetherA01"){str2 = "Clueless Ghost and Awkward Half Human";}
	
	if(IsCommonDataAreaExists("c_Player_v1")){str2 = GetAreaCommonData("c_Player_v1", "NegativeName", "Flowers");}
	
	CutInS1(Enemy, "NAZRIN", "\""~str~""~str2~"\"", BossCutIn, 0, 0, 238, 511);
	ObjEnemyBossScene_StartSpell(objScene);
	PlaySound("spell");	
    
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(Obj_IsDeleted(Enemy)==false){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(EnemyDead == false){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 0;
	let sframe2 = -1;
	let sframe3 = 0;
	let s = 0;
	let sloop = 0;
	loop(64){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe==25){
			if(s==0){ConcentrationF3(Enemy, 255, 76, 76, 35);PlaySound("charge");Anim_Attack = 1;}
			s++;if(s>=6){s = 0;}
		}
		
		if(sframe==60){
			Enemy_Move+=55;
			let nan = GetAngleToPlayer(Enemy)-(argument/1.35)+8;
			sloop = round(argument/8)+3;
			loop(sloop){
				CreateObjShotA2(EnemyX, EnemyY, (argument/24+2.45)/1.65, nan, DS_BALL_S_YELLOW, 13,255,255,64);
				nan += ((argument/1.35)*2)/sloop;
			}
			PlaySound("labullet");
			sframe = -15;Anim_Attack=0;
		}
		
		if(sframe2>9-argument/12){		
			CreateObjShotA2(EnemyX+56, EnemyY-32, (argument/32+2.45)/1.65, 90+85*sin(angle), DS_BALL_S_YELLOW, 13,255,255,64);
			CreateObjShotA2(EnemyX-56, EnemyY-32, (argument/32+2.45)/1.65, 90+85*sin(180+angle), DS_BALL_S_YELLOW, 13,255,255,64);
			
			CreateObjShotA2(EnemyX+56, EnemyY+32, (argument/32+2.45)/1.65, 180+90+85*sin(angle), DS_BALL_S_YELLOW, 13,255,255,64);
			CreateObjShotA2(EnemyX-56, EnemyY+32, (argument/32+2.45)/1.65, 180+90+85*sin(180+angle), DS_BALL_S_YELLOW, 13,255,255,64);
				
			PlaySound("smbullet");
			sframe2 = 0;
		}
		sframe2++;
		sframe++;
		angle++;
		Enemy_Move++;
		yield;
	}
	FinalizeSpell;
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateObjShotA2(x, y, spd, ang, graph, delay,r,g,b){
	let ospd = spd;
	spd = 8;
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	
	ObjMove_SetSpeed(objShot, spd);
	ObjMove_SetMaxSpeed(objShot, 0);
	ObjMove_SetAcceleration(objShot, -0.25);
	
	while(!Obj_IsDeleted(objShot)&&ObjMove_GetSpeed(objShot)>0.35){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		if(GetPlayerState==STATE_DOWN){Obj_Delete(objShot);}
		yield;
	}
	
	if(!Obj_IsDeleted(objShot)){
		CreateObjShotM1(x, y, ospd, ang, 301, delay, r,g,b,"yellow");
		PlaySound("smbullet");
		Obj_Delete(objShot);
		return;
	}
	if(quality<=1){return;}
	ObjShot_BulletBreak(x, y, r, g, b);
}



