//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

//Abandoned Spellcard

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss3.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

let TotalDollCount = 0;

@Event{
	alternative(GetEventType)
	//1;490;2450
	case(EV_REQUEST_IS_DURABLE_SPELL){SetScriptResult(false);}
	case(EV_REQUEST_LIFE){SetScriptResult(490);}
	case(EV_REQUEST_TIMER){SetScriptResult(45);}
	case(EV_REQUEST_SPELL_SCORE){SetScriptResult(8750000);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	
	ObjRender_SetPosition(Enemy, GetStgFrameWidth/2-96, -164, 0);
	AnimateBossD1(Enemy, 48, 64);
	SetInvincibility(Enemy, 300, 25, 10);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 10, 3);
	
	
	let str = "Dolls of the Round Table";
	if(argument == 12){str = "Dolls of the Round Table";}
	if(argument == 36){str = "Dolls of the Round Table";}
	if(argument == 48){str = "Dolls of the Round Table";}
	if(argument == 72){str = "Dolls of the Round Table";}
	if(argument >= 73){str = "Dolls of the Round Table";}
	CutInS1(Enemy, "NAZRIN", "Recollection \""~str~"\"", BossCutIn, 0, 0, 255, 511);
	ObjEnemyBossScene_StartSpell(objScene);
	PlaySound("spell");
    
	SatoriActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
  
task ChangeAcceleration(obj, del, acc){
	loop(del){yield;}
	ObjMove_SetAcceleration(obj, acc);
}
task ChangeAccelerationMax(obj, del, acc, max){
	loop(del){yield;}
	ObjMove_SetAcceleration(obj, acc);
	ObjMove_SetMaxSpeed(obj, max);
}
    

task SetScriptProperties{
	if(Obj_IsDeleted(Enemy)==false){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(EnemyDead == false){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task SatoriActions{
	let Enemy_Move = 0;
	let sframe = 140;
	let sframe2 = -1;
	let sloop = 0;
	loop(64){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe>=20){
			let a = rand(0,360);
			sloop = round(argument/24)+7;
			sframe2+=2;
			if(sframe2>=2){sframe2 = -1}
			if(TotalDollCount<sloop*(round(argument/24)+2.25)){
				loop(sloop){
					CreateDoll(EnemyX, EnemyY, argument/24+2, GetAngleToPlayer(Enemy));
					a += (360/(sloop));
				}
				PlaySound("labullet");
			}
			Enemy_Move+=400;
			sframe = 0;
		}
		sframe++;
		if(GetPlayerState==STATE_DOWN&&argument<48){sframe = 185}
		Enemy_Move++;
		yield;
	}
	CreateCircleA1(Enemy, 0, 7, 128, 255, 128, 64);
	PlaySound("barrage");
	loop(quality*20){ExplosionA2(EnemyX, EnemyY, rand(-360, 360), rand(-360, 360), rand(-360, 360), rand(1, 3));}	
	yield;
	FinalizeSpell;
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateDoll(x, y, spd, ang){
	let f = CreateEnemyObject(100, imgEnemy, 144, 128, 178, 176);
	ObjMove_SetSpeed(f, spd);
	ObjMove_SetAngle(f, ang);
	ObjSprite2D_SetDestCenter(f);
	SetInvincibility(f, 0, 100, 100);
	PlayEnemyHitSound(f, 2);
	ObjRender_SetPosition(f, x, y, 0);
	ObjRender_SetScaleXYZ(f, 0.8, 0.8, 1);
	TotalDollCount++;
	let anim = 0;
	let anim_type = 1;
	let cno = 1;
	let move = 0;
	
	while(!Obj_IsDeleted(f)&&!EnemyDead&&GetPlayerState!=STATE_DOWN&&ObjEnemy_GetInfo(f,INFO_LIFE)>0){
		if(CheckOutsideScreen(f, 48)){Obj_Delete(f);}
		ObjEnemy_SetIntersectionCircleToShot(f, ObjRender_GetX(f), ObjRender_GetY(f), 14);
		if(cno>0){
			anim++;
			if(anim_type == 0){
				ObjRender_SetAngleZ(f, 0);
				if(anim >= 0){ObjSprite2D_SetSourceRect(f, 0, 128, 63, 176);}
				if(anim >= 5){ObjSprite2D_SetSourceRect(f, 64, 128, 127, 176);}
				if(anim >= 10){anim = -1;}
				if(ang>-90&&ang<90){ObjRender_SetScaleXYZ(f, 0.8, 0.8, 1);}
					else{ObjRender_SetScaleXYZ(f, -0.8, 0.8, 1);}
				ObjEnemy_SetIntersectionCircleToPlayer(f, ObjRender_GetX(f), ObjRender_GetY(f), 14);
			}else{
				ObjRender_SetScaleXYZ(f, 0.8, 0.8, 1);
				ObjRender_SetAngleZ(f, ang);
				if(anim >= 0){ObjSprite2D_SetSourceRect(f, 0, 49+130, 87, 97+127);}
				if(anim >= 3){ObjSprite2D_SetSourceRect(f, 88, 49+130, 175, 97+127);}
				if(anim >= 6){anim = -1;}
				if(ang>-90&&ang<90){ObjRender_SetScaleXYZ(f, 0.8, 0.8, 1);}
					else{ObjRender_SetScaleXYZ(f, 0.8, -0.8, 1);}
				ObjEnemy_SetIntersectionCircleToPlayer(f, ObjRender_GetX(f), ObjRender_GetY(f), 20);
			}
			ObjSprite2D_SetDestCenter(f);
		}else{
			ObjRender_SetAngleZ(f, 210+move*25);
		}
		yield;
	}
	TotalDollCount--;
	if(Obj_IsDeleted(f)){return;}
	let qual = GetCommonData("quality", 2);
	loop(1){ExplosionB1(ObjRender_GetX(f), ObjRender_GetY(f), "blue", 0, 0, 0);}
	loop(qual*2){ExplosionB2(ObjRender_GetX(f), ObjRender_GetY(f), 64, 64, 255, rand(1, 3));}
	PlaySound("death2");
	Obj_Delete(f);
}






