
let current = GetCurrentScriptDirectory;
let spbg1 = current~"cdbg1b.png";
let spbg2 = current~"cdbg2b.png";
let SpellActive = false;

@Initialize{	
	SpellBG;
}
@MainLoop{
	let a = GetEnemyBossSceneObjectID;
	if(a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL)){
		SpellActive = true;
	}else{
		SpellActive = false;
	}
	yield;
}


task SpellBG{
	let cdbg2X = 0;
	let cdbg2X2 = 0;
	let fade = 0;
	
	let cdbg1Obj = SetBG1Properties;
	let cdbg2Obj1 = SetBG2Properties;
	
	while(!IsCloseScript(GetScriptArgument("PluralID"))){
		if(SpellActive){
			fade = min(fade+12.75, 255);
		}else{
			fade=0;
		}
		cdbg2X2-=0.35;
		ObjRender_SetAngleZ(cdbg1Obj, cdbg2X2);
		
		
		ObjRender_SetAlpha(cdbg1Obj, fade);
		ObjRender_SetAlpha(cdbg2Obj1, fade);
		
		yield;
	}
	
	Obj_Delete(cdbg1Obj);
	Obj_Delete(cdbg2Obj1);
	CloseScript(GetOwnScriptID);
	
	function SetBG1Properties{
		let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
		ObjRender_SetAlpha(BG2PropObj, fade);
		Obj_SetRenderPriority(BG2PropObj, 0.23);
		ObjPrim_SetTexture(BG2PropObj, spbg2);
		ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, 256, 256);
		ObjSprite2D_SetDestCenter(BG2PropObj);
		ObjRender_SetScaleXYZ(BG2PropObj, 2.35, 2.35, 1);
		ObjRender_SetPosition(BG2PropObj, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
		return BG2PropObj;
	}
	function SetBG2Properties{
		let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
		ObjRender_SetAlpha(BG2PropObj, fade);
		Obj_SetRenderPriority(BG2PropObj, 0.22);
		ObjPrim_SetTexture(BG2PropObj, spbg1);
		ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, 256, 256);
		ObjSprite2D_SetDestCenter(BG2PropObj);
		ObjRender_SetScaleXYZ(BG2PropObj, 2, 2, 1);
		ObjRender_SetPosition(BG2PropObj, GetStgFrameWidth/2, GetStgFrameHeight/2, 0);
		return BG2PropObj;
	}
	task SetColorAlpha(div){
		ObjRender_SetColor(cdbg1Obj, div, div, div);
	}
}



