//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(39);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 45, 175, 110);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 10, 3);
  
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(!Obj_IsDeleted(Enemy)){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(!EnemyDead){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 145;
	let sframe2 = -1;
	let sframe3 = -6;
	let sloop = 0;
	let angle2 = 0;
	loop(144){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}   
		if(sframe>=185){
			if(ObjMove_GetSpeed(Enemy)<1){Anim_Attack = 1;}
			if(sframe3>5-round(argument/24)){
				sloop = round(argument/12)+3;
				let sloop2 = sloop/1.35;
				loop(sloop){
					CreateObjShotA1(EnemyX+12*cos(angle), EnemyY+12*sin(angle), argument/32+2.75, angle, DS_BALL_M_A_RED+round(rand(0,7)), 13,255,255,255);
					angle+=360/sloop;
				}
				loop(sloop2){
					CreateObjShotA1(EnemyX+12*cos(angle2), EnemyY+12*sin(angle2), argument/42+2.55, angle2, DS_BALL_M_A_RED+round(rand(0,7)), 13,255,255,255);
					angle2+=360/sloop2;
				}
				PlaySound("smbullet");
				sframe3 = 0;
			}
			sframe3++;
			angle+=3.45;
			angle2+=1.75;
			if(sframe>=305){
				Anim_Attack = 0;
				sframe = 0;
			}
		}
		sframe++;
		Enemy_Move++;
		yield;
	}
	EnemyDead = true;
	Obj_Delete(Enemy);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

