//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(2500);}
	case(EV_REQUEST_TIMER){SetScriptResult(39);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 175, 135, 110);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/4, 10, 3);
  
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(!Obj_IsDeleted(Enemy)){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(!EnemyDead){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 145;
	let sframe22 = -1;
	let s = 28;
	let s2 = 0;
	let sloop = 0;
	let angle2 = 0;
	let cx = GetCenterX;
	let cy = GetCenterY*1.35;
	let bx = GetCenterX;
	let by = GetCenterY*1.35;
	loop(144){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe>=144-argument/1.35){
			let nan = GetAngleToPlayer(Enemy);
			sloop = round(argument/8)+2;
			let sloop2 = sloop/1.35;
			loop(sloop){
				CreateObjShotA2(EnemyX, EnemyY, argument/34+2.25, nan, DS_BALL_L_YELLOW, 13,255,255,64,sframe22);
				nan +=360/sloop;
			}
			PlaySound("smbullet");
			sframe = 0;
			sframe22+=2;
			if(sframe22>=2){sframe22 = -1}
		}
		sframe++;
		Enemy_Move++;
		yield;
	}
	EnemyDead = true;
	Obj_Delete(Enemy);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateObjShotA2(x, y, spd, ang, graph, delay,r,g,b, sframe22){
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	ObjMove_SetSpeed(objShot, spd);
	
	let bfr = 0;
	ang += rand(-15, 15);
	
	while(!Obj_IsDeleted(objShot)){
		bfr+=argument/16;
		if(bfr>=22){
			let s = CreateObjShotA1(ObjMove_GetX(objShot), ObjMove_GetY(objShot), 0, ang, DS_BALL_S_BLUE, 13,64,64,255);
			SetAcceleration(s);
			PlaySound("smbullet");
			ang+=18*sframe22;
			bfr = 0;
		}
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		yield;
	}
	
	if(quality<=1){return;}
	ObjShot_BulletBreak(x, y, r, g, b);
	
	task SetAcceleration(s){
		ObjMove_SetMaxSpeed(s, argument/32+1.25);
		loop(70){yield;}
		ObjMove_SetAcceleration(s, 0.05);
	}
}


