//TouhouDanmakufu[Plural]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/PluralFunctions.h"


let objStar1 = ObjPrim_Create(OBJ_SPRITE_2D);

let current = GetCurrentScriptDirectory;
let source = current;

let timer = 0;

@Initialize{
	let Background = LoadScript(source ~ "background.h");
	SetScriptArgument(Background, "PluralID", GetOwnScriptID);
	StartScript(Background);
	
	PluralTask;
	//DistortInvalidScreenA1(objStar1, 20, 79);
	SetStars;
}

@MainLoop{
	yield;
}

@Finalize{
	SetCommonData("StarX1", -400);
	SetCommonData("StarY1", -400);
}


task PluralTask{
	let obj = ObjEnemyBossScene_Create;
	ascent(i in 1..9){
		ObjEnemyBossScene_Add(obj, i, source ~ "NonSpell0"~IntToString(i)~".h");
		ObjEnemyBossScene_Add(obj, i, source ~ "Spell0"~IntToString(i)~".h");
	}
	ObjEnemyBossScene_Add(obj, 9, source ~ "Spell09.h");
	ObjEnemyBossScene_LoadInThread(obj);
	ObjEnemyBossScene_Regist(obj);
	
	while(!Obj_IsDeleted(obj)){
		yield;
	}
	loop(180){yield;}
	Obj_Delete(objStar1);
	yield;
	CloseScript(GetOwnScriptID);
}

task SetStars{
	SetCommonData("ForceLifebar", 1);
	loop(85){yield;}
	SetCommonData("ForceLifebar", 0);
	BackgroundBulgeA2(objStar1);
	StarOnBoss(objStar1, "StarX1", "StarY1");
}