//TouhouDanmakufu[Single]
#ScriptVersion[3]
#System["./ds_system/S_System.txt"]

#include"./../../../ds_system/Default_ShotConst.txt"
#include"./Animation.h"
#include"./../../../ds_system/SpellFunctions.h"

let Enemy = ID_INVALID;
let objScene = GetEnemyBossSceneObjectID;

let current = GetCurrentScriptDirectory;
let source = current;

let imgEnemy = source~"boss.png"; 



let BossCutIn = source~"cutin.png"; 

let time = 0;

let frame = 0;
let angle = 0;

let frame2 = 550;
let angle2 = 0;

let argument = GetCommonData("StageDiffic", 36);
let loopval = 10;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_IS_DURABLE_SPELL){SetScriptResult(false);}
	case(EV_REQUEST_LIFE){SetScriptResult(500);}
	case(EV_REQUEST_TIMER){SetScriptResult(55);}
	case(EV_REQUEST_SPELL_SCORE){SetScriptResult(8750000);}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 96, 96);   
	AnimateBossM1(Enemy, 48, 80);
	SetInvincibility(Enemy, 300, 25, 10);
	LoadSoundEffects;
	PlayEnemyHitSound(Enemy, 1);
	ObjMove_SetDestAtWeight(Enemy, GetStgFrameWidth/2, GetStgFrameHeight/3, 10, 3);
	
	let str = "Wild Carnivorous Transformation";
	if(argument == 12){str = "Wild Mammal Transformation";}
	if(argument == 36){str = "Wild Dog Transformation";}
	if(argument == 48){str = "Wild Wolf Transformation";}
	if(argument == 72){str = "Wild Carnivorous Transformation";}
	if(argument >= 73){str = "Wild Carnivorous Transformation";}
	CutInS1(Enemy, "NAZRIN", "New Duel \""~str~"\"", BossCutIn, 0, 0, 238, 511);
	ObjEnemyBossScene_StartSpell(objScene);
	PlaySound("spell");	
    
	BossActions;
}

@MainLoop{
	SetScriptProperties;
	yield;
}
    

task SetScriptProperties{
	if(Obj_IsDeleted(Enemy)==false){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 12);
		ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 16);
	}
	if(EnemyDead == false){
		SpellTime(objScene);
		SetCommonData("StarX1", EnemyX);
		SetCommonData("StarY1", EnemyY);
	}
	time++;
	Enemy_Move++;
}

task BossActions{
	let Enemy_Move = 0;
	let sframe = 0;
	let sframe2 = -1;
	let sframe3 = 0;
	let s = 0;
	let sloop = 0;
	loop(64){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		if(Enemy_Move>rand(345, 600)&&!IsAttackAnimPlaying){
			ObjMove_SetDestAtWeight(Enemy, rand(120, GetStgFrameWidth-120), rand(80, GetStgFrameHeight/2-75), 10, 3);
			Enemy_Move = 0;
		}
		if(sframe==75){
			if(s==0){ConcentrationF1(Enemy, 255, 76, 76, 35);PlaySound("charge");Anim_Attack = 1;}
			s++;if(s>=3){s = 0;}
		}
		
		if(sframe==100){
			Enemy_Move+=135;
			let nan = GetAngleToPlayer(Enemy);
			sloop = round(argument/3)+2;
			loop(sloop){
				CreateObjShotA1(EnemyX, EnemyY, (argument/32+2.45)/2.65, nan, DS_BALL_L_SKY, 13,64,255,255);
				nan += 360/sloop;
			}
			PlaySound("labullet");
		}
		if(sframe>=155){sframe = -45;Anim_Attack=0;Enemy_Move+=100;}
		
		if(sframe2>24-argument/8){		
			sloop = round((argument/48)+1);
			loop(sloop){
				let nan = rand(120,180);
				let ofx = rand(-10, -45);
				let ofy = rand(-35, 35);
				CreateObjShotA2(EnemyX+ofx, EnemyY+ofy, (argument/32+2.45)/1.65, nan, DS_BALL_S_GREEN, 13,64,255,64);
				nan = rand(10,60);
				CreateObjShotA2(EnemyX-ofx, EnemyY+ofy, (argument/32+2.45)/1.65, nan, DS_BALL_S_GREEN, 13,64,255,64);
			}
			PlaySound("smbullet");
			sframe2 = 0;
		}
		sframe2++;
		sframe++;
		Enemy_Move++;
		yield;
	}
	FinalizeSpell;
	loop(256+LastTimeStop){yield;}
	CloseScript(GetOwnScriptID);
}

task CreateObjShotA2(x, y, spd, ang, graph, delay,r,g,b){
	let ospd = spd;
	spd = spd/6;
	let objShot = CreateShotA1(x, y, 0,  ang, graph, 0);
	ObjShot_SetIntersectionEnable(objShot, false);
	let i = 0;
	while(i<delay&&!Obj_IsDeleted(objShot)){
		let alpf = i*(225/delay);
		let scl = (delay-i)*(1.75/delay);
		ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
		ObjRender_SetAlpha(objShot, min(255, alpf-35));
		i+=1/TimeSpeed;
		yield;
	}
	ObjShot_SetIntersectionEnable(objShot, true);
	ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
	ObjRender_SetAlpha(objShot, 255);
	
	let btime = 0;
	
	while(!Obj_IsDeleted(objShot)&&btime<45){btime++;yield;}
	graph = 297;
	if(ang>90){graph = 298;}
	ObjShot_SetGraphic(objShot, graph);
	
	let bframe = rand(0,90);
	
	while(!Obj_IsDeleted(objShot)&&!EnemyDead){
		x = ObjRender_GetX(objShot);
		y = ObjRender_GetY(objShot);
		if(GetPlayerState==STATE_DOWN){Obj_Delete(objShot);}
		
		if(bframe>=90-argument/3+rand(-25, 25)){
			let angl = 90;
			let sloop = 2;
			loop(sloop){
				let nsh = CreateObjShotA1(x, y, 0, angl, DS_NEEDLE_WHITE, 8, 255, 255, 255);
				ObjMove_SetAcceleration(nsh, 0.05);
				ObjMove_SetMaxSpeed(nsh, ospd/1.25);
				angl+=360/sloop;
			}
			PlaySound("smbullet");
			bframe = 0;
		}
		
		spd = min(spd+0.085, ospd);
		ObjMove_SetSpeed(objShot, spd);	
		if(GetPlayerState==STATE_DOWN){Obj_Delete(objShot);}
		
		btime++;
		bframe++;
		yield;
	}
	if(quality<=1){return;}
	if(graph<295){ObjShot_BulletBreak(x, y, r, g, b)}else{
	FinalizeFairy(x,y,"green");}
}



